<?php

include '../core.php';

session_start();

cabecera (1);

// El siguiente script se encarga de comprobar que los datos
// de un formulario son validos antes de enviarlos.
echo "<script type='text/javascript'>
<!--
function submit_form()
{
  if ( document.crr_form.crrID.value == ''  ||
       document.crr_form.crrID.value.search(/[^a-z,A-Z,0-9,\.,_,\@,\/,\-]/i) >= 0)
  {
    alert ('Por favor introduzca un Identificador correcto. Solo puede escribir caracteres de la \'a\' a la \'z\', números y signos\'/\', \'.\', \'-\' y \'_\'');
    document.crr_form.crrID.focus();
    return false;
  }
  if (document.crr_form.userPin.value == '')
  {
    alert ('Por favor introduzca el PIN');
    document.crr_form.userPin.focus();
    return false;
  }
  document.crr_form.submit();
  return true;
}
// -->
</script>\n";

// En la variable command guardaremos el estado de la revocacion.
// Dependiendo de su valor, entraremos en una u otra parte del codigo.
$command = $_POST["crr_command"];
$status = "revoke";
$errorCode = "a0";

switch($command) {
	
   // Por defecto mostramos el formulario en el que se le solicita
   // al usuario los datos del certificado a revocar   
   default:

      echo "<h1>Solicitud de Revocaci&oacute;n de Certificado</h1>
      <div id='tbox'>
         <h3 class='head_a2b1'>Datos de la Solicitud</h3>
            <div id='tbox_data_a1'>
	       <form method='post' action='crr.php' enctype='multipart/form-data' name='crr_form'>
	       <div id='trow'>
                  <div id='tname'><a href='help/help.php#identificador'>Identificador</a></div>
		  <div id='tvalue'><input class='form_input' type='text' name='crrID'  size='40' /> <br/>(nombre.apellido@org.dom)<br/>&nbsp;</div>
	       </div>
	       <div id='trow'>
                  <div id='tname'><a href='help/help.php#crt_copaID'>C&oacute;digo de solicitud</a></div>
		  <div id='tvalue'><input class='cajaTexto' type='text' name='copa'  size='40' /> <br/>(p. ej: <b><tt>a99b99c99</tt></b>)</div>
	       </div>
	       <div id='trow'>
                  <div id='tname'><a href='help/help.php#clave_usuario'>Clave de Usuario</a></div>
		  <div id='tvalue'><input class='cajaTexto' type='password' name='userPass'  size='40' /></div>
	       </div>
	       <div id='trow'>
                  <div id='tname'><a href='help/help.php#crt_pin'>PIN del Certificado</a></div>
		  <div id='tvalue'><input class='cajaTexto' type='password' name='userPin'  size='40' /><br/>&nbsp;</div>
	       </div>
	       <div id='trow'>
                  <div id='tname'>Motivo de la revocaci&oacute;n</div>
		  <div id='tvalue'><select name='revReason'>";
                  while (list (,$content) = each ($revReasons)) {
                     echo "<option>$content</option>";
                  }
                  echo "</select>
	          </div>
	       </div>
	       <div id='trow'>
                  <div id='tname'>Comentarios</div>
		  <div id='tvalue'><input type='text' name='comments'  size='40'></div>
	       </div>
	       <div id='trow'>
	          <div id='tvalue'>
                     <input class='button' type='button' value='Continuar' onclick='submit_form()' />
	          </div>
	       </div>
               <input type='hidden' name='crr_command' value='crr_process'>
               </form>
            </div> <!-- tbox_data_a1 -->
	 </div> <!-- tbox -->\n";
      break;

   case "crr_process":

      $copa = $_POST['copa'];
      $crrID = $_POST['crrID'];
      $userPass = $_POST['userPass'];
      $userPin = $_POST['userPin'];
      $revReason = $_POST['revReason'];
      $comments = $_POST['comments'];

      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
      $justthese = array("cn", "sn", "pkirisID");
      $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
      if ( !$result )
	 $errorCode = "a4b2c2d1e1";
      else {      
         // Verificamos si existe el codigo del certificado, si el resultado del count($result) es 1 no existe, si es 2 si existe.
         if (count($result) == 1) 
	    $errorCode = "a4b2c2d2e1";
         // Si existe, tenemos que comprobar si el identificador introducido se corresponde con ese codigo
         else {  
	   if ($result[0]["pkirisid"][0] != $crrID )
	       $errorCode = "a4b2c2d2e2";
	   else {
            // Hacemos un bind al ldap para verificar la password del usuario.
            $ds = ldap_connect($ldapVar['server'], $ldapVar['port']);
         
            if ( !$ds ) 
  	       $errorCode = "a4b2c2d1e3";
            else {
 	       list ($userCopa, $kk) = split ("c", $copa);
               $dn = $ldapVar['rdnAttr']."=".$userCopa.",".$ldapVar['base'];
               $ldapbind = ldap_bind($ds, $dn, $userPass);
   
     	       if (!$ldapbind)
                  $errorCode = "a4b2c2d1e4";
               else {
	          
                  // Buscamos la informacion del certificado que tenga el 
		  // usuario en estado 'issued'
                  $filter2 = "(&(objectClass=pkirisCertificate)(pkirisStatus=issued)(pkirisCopaID=$copa))";
                  $justthese = array("dn", "pkiriscerttype", "pkirispin");
  
                  $result2 = ldap_get_info($ldapVar['base'], $filter2, $justthese);
      
		  if ( !$result )
 	             $errorCode = "a4b2c2d1e1";
		  else {       
                     if (count($result2) == 1) 
 		        $errorCode = "a4b2c2d2e3";
                     else {
                        // Comparamos los pines para ver si son iguales
                        if (crypt($userPin, $result2[0]["pkirispin"][0]) != $result2[0]["pkirispin"][0])
                     	   $errorCode = "a4b2c2d2e4";
                        else {
                           // Obtenemos el Certificado del usuario, lo pasamos
		           // a un archivo como .der y luego lo pasamos a .txt
                           $userCert = ldap_get_cert($ldapVar['base'], $filter2);

			   // Si ha habido algun error, anotamos el error y no 
			   // continuamos
                           if (!$userCert)
			      $errorCode = "a4b2c2d1e5";
                           else {
			      $filter = "(&(objectClass=pkirisEndEntity)(pkirisCopaID=$userCopa))";
  			      $justthese = array("cn", "sn");
  	                      $result3 = ldap_get_info($ldapVar['base'], $filter, $justthese);
			      if ( !$result3 )
				 $errorCode = "a4b2c2d1e1";
			      else {
			         $cn = $result3[0]["cn"][0];
                                 $sn = $result3[0]["sn"][0];
                                 $type = $result2[0]["pkiriscerttype"][0];
                                 $dn = $result2[0]["dn"];
  
                    	         echo "<h2>Datos sobre la solicitud de Revocaci&oacute;n (CRR)</h2>
                                 <table border='0' cellpadding='0' cellspacing='0'>
                                 <tr><td class='header'>Identificador</td><td class='even'>$crrID</td></tr>
                                 <tr><td class='header'>C&oacute;digo de solicitud</td><td class='odd'>$copa</td></tr>
                                 <tr><td class='header'>Nombre</td><td class='even'>" . $cn . " " . $sn ."</td></tr>";
 
                                 if ($type == "srv") 
                                    echo "<tr><td class='header'>Tipo</td><td class='odd'>Certificado de Servidor</td></tr>";
                                 else 
                                    echo "<tr><td class='header'>Tipo</td><td class='odd'>Certificado de Usuario</td></tr>";
                                 echo "</table>
                                 <h2>Datos sobre el certificado que se va a revocar</h2> 
			               <div id='tbox'>
                                    <h3 class='head_a2b1'>Certificado a Revocar</h3>
			               <div id='tbox_data_a1'><pre>\n";

                                 $derFile = $dirVar['crt'] . $copa.".x509ee";
                                 // Verificamos si existe el fichero y si no lo 
			         // creamos y volcamos la info del certificado en el
                                 if (!file_exists($filename)) {
                                    $der = fopen($derFile, "w");
                                    fputs($der, $userCert[0]);
                                    fclose($der);
                                 }

			         // BUSCAR FUNCION QUE DEVUELVA EL SERIAL EN PHP
                                 $txtCert = exec($bin['openssl'] . " x509 -text -inform DER < " .$derFile, $result);
         
                                 for($i = 1; $i < count($result); $i++)
                                    echo "$result[$i]\n"; 
                         
			         echo "</div>
                                 </div></pre>

                                 <form method='post' action='crr.php' enctype='multipart/form-data' name='crr_form'>
                                 <input class='button' type=submit value='Revocar'>
                                 <input type='hidden' name='copa' value='$copa'>
			         <input type='hidden' name='userCopa' value='$userCopa'>
                                 <input type='hidden' name='dn' value='$dn'>
			         <input type='hidden' name='errorCode'  value='$errorCode'>
			         <input type='hidden' name='comments' value='$comments'>
			         <input type='hidden' name='crr_reason' value='$revReason'>
			         <input type='hidden' name='crr_command' value='crr_makeXml'>
                                 </form>\n";
		              }  
                           }
		        }	    
                     }
                  }
               }
            }
	 } 
      } 
   }
      break;

   case "crr_makeXml":
      $copa = $_POST['copa'];
      $userCopa = $_POST['userCopa'];
      $dn = $_POST['dn'];
      $errorCode = $_POST['errorCode'];
      $comments = $_POST['comments'];
      $crr_reason = $_POST['crr_reason'];

      $lastStatus = getStatus($copa);
      if ( !$lastStatus )
	 $errorCode = "a4b2c2d2e5";
      else {
         // Esta comprobacion se hace para evitar que se escriba dos veces la
         // misma traza y el mismo xml al recargar el navegador
         if ($lastStatus == "issued") {
 
            $currentDate = date("YmdHis");
            $invalidityDate = $currentDate; // En un futuro, esta variable tendra otro valor
      
            $traceVals["status"] = $status;
            $traceVals["copa"] = $copa;
            $traceVals["currentDate"] = $currentDate;
            $traceVals["invalidityDate"] = $invalidityDate;
            $traceVals["revocationReason"] = $crr_reason;
            $traceVals["comments"] = $comments;
      
            // Construimos la urn con los valores especificados en $traceVals
            $pkiTrace =  getTrace ($traceVals); 
            if ( !$pkiTrace ) 
	       $errorCode = "a4b2c2d2e8";
            else{
               // Cambiamos los estados de pkirisStatus, pkirisDate y 
      	       // pkirisRevocationReason
               $updateFields["pkirisstatus"] = $status;
               $updateFields["pkirisdate"] = $currentDate;
               $updateFields["pkirisrevocationreason"] = $crr_reason;
  	       $updateFields["pkirisrevokedbycopaid"] = $userCopa;
      
	       $r=ldap_mod_info($dn, $updateFields);
               if (!$r)
                  $errorCode = "a4b2c2d1e6";
               else {
                  // Insertamos la traza en ldap
                  $urn["pkiristrace"] = $pkiTrace;
                  $r=ldap_mod_add_info($dn, $urn);
  	          if (!$r)
                     $errorCode = "a4b2c2d1e7";
		  else {
	             // Si no ha habido errores, generarmos el fichero XML para enviar los
	             // datos a la CA		     
                     $r = createXML ( array($copa) );
	             if (!$r)
                        $errorCode = "a4b2c2d2e6";
                  }
	       }
            }
         }
         else	      
            $errorCode = "a4b2c2d2e7";
      }

      // Si no ha habido errores, escribimos en el fichero de log
      if ( $errorCode == "a0" ) {
         echo "<h1>Solicitud de Revocaci&oacute;n</h1><h2> Solicitud Aceptada </h2>
               <p> Su solicitud de revocaci&oacute;n ha sido aceptada y sera enviada de inmediato al administrador de la CA para revocar el certificado indicado.</p>";
						        
         // Escribimos en el fichero de log los cambios de estado realizados
         $pkiLog['status'] = $status;
         $pkiLog['eee'] = $copa;
         $pkiLog['user'] = "Publico";
         $pkiLog['error'] = $errorCode;
         writeLog ($pkiLog);
      }

      break;   
}

// Si se ha producido algun error, llamamos a la funcion encargada de 
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error en la Solicitud de Revocaci&oacute;n </h2>
         <p> No ha sido posible generar su solicitud.</p>\n";

   $pkiLog['status'] = $status;
   $pkiLog['eee'] = $copa;
   $pkiLog['user'] = "Publico";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>
